Subject: Image caching broken for im_noScaleUp = 1
Description
Regarding T3CMS V6.0.0

In the BE first everyting is OK.
The CE Image is all OK, the preview is shown corectly
In FE all is OK, too.

Then | have set im_noScaleUp = 1 in the install tool.

Now, FE and BE are filled up with Errors:

Uncaught TYPO3 Exception

#1329821485: File has been deleted. (More information)

RuntimeException thrown in file
typo3_src-6.0.0/typo3/sysext/core/Classes/Resource/AbstractFile.php in line 492.

9 TYPO3\CMS\Core\Resource\AbstractFile::getPublicUrl(boolean)
typo3_src-6.0.0/typo3/sysext/backend/Classes/Form/Element/InlineElement.php:

00555:  unset($imageSetup['field]);

00556:  $imageSetup = array_merge(array('width' => 64, 'height' => 64), $imageSetup);
00557:  $imageUrl = $fileObject->process(\TYPO3\CMS\Core\Resource\ProcessedFile:: CONTEXT_IMAGEPREVIEW,
$imageSetup)->getPublicUrl(TRUE);

00558:  $thumbnail =" . htmlspecialchars($recTitle) . ";

00559: }else{

In BE and FE | have to click the reload Btton for every Image in the page, and jes, | have up to 1500pics on a single page! Happy
Clicking.

All image-cache is broken, a extbase-Extention with lots of pictures have the same problem.
Reloading the page once per image, heples.
Clearing the Cache, even by emptying the cache-table does bot help or deleting the temp-folder.

Related issues:

related to Core - Bug # 58889: Checksum in generated images changes Closed 2014-05-17
related to Core - Bug # 44073: Checksum needs to be updated after file proces... Resolved 2012-12-17
related to Core - Bug # 45308: uid of processed file is sometimes updated dur... Resolved 2013-02-09
duplicated by Core - Bug # 45168: Wrong image displayed in FE if not resized Resolved 2013-02-05

Associated revisions
Revision 5516¢309 - 2013-02-09 12:09 - Andreas Wolf

[BUGFIX] Processed files get corrupted when regenerated

After a file is being (re)processed, the information about it is updated
in the database by the ProcessedFileRepository. The repository gathers

information for the update from the processed file.

For unprocessed files (i.e. those where the original file should be
used), the ProcessedFile class does a fallback to the original file
object. Unfortunately, this fallback is also applied for the uid

property, which makes the repository overwrite a random record in
sys_file_processedfile. This leads to wrong images being displayed in
the frontend.

This patch makes the processed file only return its own uid.

IMPORTANT: To make sure your sys_file_processedfile data is not
corrupted, empty the table and your processed files folder (usually
fileadmin/_processed_/). This will slow down your site as all processed
files are regenerated, but afterwards all data will be correct.

Change-Id: 140685d5748a5a0fcf015¢c7d876a374f42154831d
Resolves: #45308

Related: #44616 #45168

Releases: 6.1, 6.0

Reviewed-on: https://review.typo3.org/18145

Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel
Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring

Revision 91a1d0a3 - 2013-02-09 12:23 - Andreas Wolf

[BUGFIX] Processed files get corrupted when regenerated

After a file is being (re)processed, the information about it is updated
in the database by the ProcessedFileRepository. The repository gathers

information for the update from the processed file.

For unprocessed files (i.e. those where the original file should be
used), the ProcessedFile class does a fallback to the original file
object. Unfortunately, this fallback is also applied for the uid

property, which makes the repository overwrite a random record in
sys_file_processedfile. This leads to wrong images being displayed in
the frontend.

This patch makes the processed file only return its own uid.
IMPORTANT: To make sure your sys_file_processedfile data is not

corrupted, empty the table and your processed files folder (usually
fileadmin/_processed_/). This will slow down your site as all processed
files are regenerated, but afterwards all data will be correct.

Change-Id: 140685d5748a5a0fcf015c7d876a374f42154831d
Resolves: #45308

Related: #44616 #45168

Releases: 6.1, 6.0

Reviewed-on: https://review.typo3.org/18153

Reviewed-by: Andreas Wolf
Tested-by: Andreas Wolf

History

#1 - 2013-01-17 20:33 - Christian Tauscher

Workaround:

truncate sys_file_processedfile

seems to solve the Problem. Dont know what this will have for side-Effects.

Can this table (even ist a sys-table) deleted from time to time?

#2 - 2013-01-18 09:23 - Andreas Wolf

- Category changed from Caching to File Abstraction Layer (FAL)

- Status changed from New to Accepted

- Assigned To set to Andreas Wolf

- Target version set to 6.0.1

Christian Tauscher wrote:

Workaround:

truncate sys_file_processedfile

seems to solve the Problem. Dont know what this will have for side-Effects.

Can this table (even ist a sys-table) deleted from time to time?

Hm, no. This table is only a cache table, but you should not truncate it, otherwise all generated images have to be regenerated, so that's no viable
solution for almost all sites.

| guess the problem is that there is no proper detection that the image has not been reprocessed (because of the noscaleup parameter). The point is
that a part of the cached image's identifier is a hash of the image processing information. Therefore, setting im_noscaleup does invalidate all cached
images. | think that this together with the bug you found completely breaks your FE output.

I'll try to dig into this, but my spare time is really limited currently. However, if you could contact me via Jabber, we can maybe sort this out a lot faster

(Jabber ID awolf (at) jabber.ccc.de).

#3 - 2013-01-18 09:24 - Andreas Wolf
- Subject changed from Error thrown by FAL to Image caching broken for im_noScaleUp = 1

#4 - 2013-01-18 10:12 - Christian Tauscher

Sorry, Andreas....
i have no idea how this jabber-dinges work.

| should know about this - many of may cstomers like this Jabber-ICQ-ircchannels, but | never got into this.

What for? | have e-mail and a phone...? Maybe we could communicate throug one of this channels.

Best regards from stone-age ;-)

Christian.

#5 - 2013-02-04 10:47 - Camelia M

| have a similar problem with im_noScaleUp = 1 but it's even weirder. | occasionally get different images in front-end then backend. | assume it's also

related to caching because link in frontend leads to a (wrong) 'processed' image.

#6 - 2013-02-04 11:58 - Andreas Wolf

Camelia M wrote:

I have a similar problem with im_noScaleUp = 1 but it's even weirder. | occasionally get different images in front-end then backend. | assume it's

also related to caching because link in frontend leads to a (wrong) processed’ image.

| think your problems could be related to the files having the same filename after being replaced? Could you check #44645 if your situation is similar?

#7 - 2013-02-04 13:38 - Camelia M

Andreas Wolf wrote:

Camelia M wrote:

I have a similar problem with im_noScaleUp = 1 but it's even weirder. | occasionally get different images in front-end then backend. | assume it's

also related to caching because link in frontend leads to a (wrong) processed' image.

| think your problems could be related to the files having the same filename after being replaced? Could you check #44645 if your situation is

similar?

I'm afraid not. My images have different names and the filename in 'processed’ folder is built as 'preview_'+original_name+some_unique_code.
But even though file names are not the same, as soon as | make 'im_noScaleUp = 1' images get mixed in a very strange way. (before activating no

scale up images are corect, after activating, other images, with other sizes replace the correct ones).

#8 - 2013-02-04 14:10 - Camelia M

It seems | have several files that have originalfilesha1 identical. | think this is not normal. Is it?
#9 - 2013-02-04 14:56 - Camelia M

Camelia M wrote:

It seems | have several files that have originalfilesha1 identical. | think this is not normal. Is it?

And they also point to the same id of sys_file (column original in 'sys_file_processedfile') even tough they have a different name and they are

completely different images.

#10 - 2013-02-07 11:50 - Andreas Wolf

Camelia M wrote:

Camelia M wrote:

It seems | have several files that have originalfileshat identical. | think this is not normal. Is it?

And they also point to the same id of sys_file (column original in 'sys_file_processedfile') even tough they have a different name and they are
completely different images.

This is really weird. Would you mind providing me with a dump of your sys_file, sys_file_processedfile tables? You could send it to me via email so |

can analyze it (just drop me a note to andreas.wolf (at) typo3.org).

#11 - 2013-02-07 22:07 - Andreas Wolf

(Crosspost from #45168)

Could anyone of you who experiences this error run the following SQL query and report on the results?

SELECT s.uid, f.storage, s.name AS processedname, s.identifier AS processedidentifier, f.name AS origname, f.identifier AS origidentifier, s.checksum
FROM sys_file_processedfile AS s LEFT JOIN sys_file AS f ON s.uid=f.uid WHERE LOCATE(s.checksum, s.name) = 0

The interesting part is if the name in processedname does not contain (parts of) origname. Then you experience a bug | found today with the help of
Camelia.

| am not sure what causes the bug, but its pretty obvious that at some point the uids of the processed file and the original file get mixed up and the
database ends corrupted. This is however no problem, as we can simply flush the processed file cache once this bug is fixed.

#12 - 2013-02-08 12:58 - Andreas Wolf

After reading the issue description again, | realized that this is in fact a duplicate of #44073. The patch for this solves the issue with a wrong
checksum, which lead to the original problem.

The hint | found with the non-matching checksum in filename and checksum column is therefore invalid - the search goes on...

#13 - 2013-02-09 11:19 - Andreas Wolf
- Status changed from Accepted to Needs Feedback

I will close this issue soon if nobody can reproduce this with 6.0.1.

#14 - 2013-02-12 11:06 - Christian Tauscher

This issue seems to be fixed with an update on 6.0.1

Thank you for your work.

Christian.

#15 - 2013-04-05 10:55 - Andreas Wolf
- Status changed from Needs Feedback to Closed

Closing this as presumably the problem has been fixed with 6.0.1
